program miniace;

{$apptype console}

uses windows,sysutils,
  unace;

{$R *.RES}

function ProgressProc(Addr:pbyte;Size:longint):longint;
var percent:longint;
    Msg:tmsg;
begin
  result:=1;
  write('.');
  if peekmessage(Msg,0,0,0,PM_Remove) then begin
    TranslateMessage(Msg);
    DispatchMessage(Msg);
  end;
end;

function ChangeProc(ArcName:pchar;Mode:longint):longint;
var buf:array[0..259] of char;
begin
  result:=1;
  if Mode=ACEVOL_REQUEST then begin
    writeln;
    writeln('Next ACE file (',Arcname,', X=abort):');
    readln(buf);
    if buf[0]<>#0 then strcopy(ArcName,buf);
    if stricomp(buf,'X')=0 then result:=0;
  end;
end;

var ACEOpenArchiveData:tACEOpenArchiveData;
    ACEHeaderData:tACEHeaderData;
    packedfile:array[0..259] of char;
    unacehandle:thandle;
    err:integer;

begin
  writeln('Unpack ACE files to current dir');
  if paramcount=0 then begin
    writeln('Usage: miniace acefile.ace');
    exit
  end;
  if not LoadAceDLL then begin
    writeln('Unace.dll not found!');
    exit
  end;
  fillchar(ACEOpenArchiveData, sizeof(tACEOpenArchiveData),#0);
  strpcopy(packedfile,paramstr(1));
  with ACEOpenArchiveData do begin
    ArcName:=packedfile;
    OpenMode:=ACEOPEN_EXTRACT;
    ProcessDataProc:=@ProgressProc;
    ChangeVolProc:=@ChangeProc;
  end;
  unacehandle:=ACEOpenArchive(ACEOpenArchiveData);
  if ACEOpenArchiveData.OpenResult<>0 then begin
    ACECloseArchive(unacehandle);
    writeln('Cannot open archive!');
    exit;
  end;
  {Process data, unpack files!}
  fillchar(ACEHeaderData,sizeof(tACEHeaderData),#0);
  err:=0;
  repeat
    err:=ACEReadHeader(unacehandle,ACEHeaderData);
    if err=0 then begin
      OemToAnsi(ACEHeaderData.FileName,ACEHeaderData.FileName);
      {If needunpack then} begin    {found -> Unpack!}
        write(ACEHeaderData.FileName,' ');
        err:=ACEProcessFile(unacehandle,ACECMD_EXTRACT,ACEHeaderData.FileName);
        writeln;
      end {else
        err:=ACEProcessFile(unacehandle,ACECMD_SKIP,nil)};
    end;
  until err<>0;
  if err<>ACEERR_END then
    writeln('Error unpacking files!');
  ACECloseArchive(unacehandle);
end.
